package net.sourceforge.rapidprops;

import java.lang.annotation.Documented;
import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

import static net.sourceforge.rapidprops.PropConstants.*; 

@Documented
@Retention(RetentionPolicy.RUNTIME)
@Target(ElementType.METHOD)
public @interface Prop {
	String NULL = "net.sourceforge.rapidprops.Prop.<NULL>";
	String EMPTY = "net.sourceforge.rapidprops.Prop.<EMPTY>";
	
	/** The key used to identify this property */
	String key() default "";
	
	/** The default value of this property. A null default value can be specified by using Prop.{@link #NULL} */
	String defaultValue() default NOT_AVAILABLE;

	/** The string used to denote the null value*/
	String nullAlias() default NULL_ALIAS;

	/** The delimiter of the elements in an array */
	String delimiter() default DEFAULT_DELIMITER;
	
	/** The default value of an element of the array or list denoted by this property. A null default value can be specified by using Prop.{@link #NULL} */
	String defaultElementValue() default NOT_AVAILABLE;
}
